######################################################
# DNSLookUP.tcl                                      #
# MyCraft                           (c) 2001 Nov 09  #
# EMail                             MyCraft@gmx.net  #
#   bersetzt von physicus <physicus@smart-irc.de>   #
######################################################
#                                                    #
#   -->>Eingabe im channel !dns <ip>/<nick> <<--     #
#                                                    #
# Beschreibung:                                      #
# Fr eine Ausgabe gib die Host oder den Nick ein    #
# Du brauchst die Berechtigung um ' nslookup '       # 
# binary ber Deine Shell abrufen zu drfen,         #
# das ist aber Grundeinstellung aller Anbieter.      #
######################################################

bind pub -|- \!dns pub_dns_lookup_req
bind msg -|- dns msg_dns_lookup_req

## >>> >> > ! ACHTUNG ! ab hier bitte nichts ndern hier beginnt der Code < << <<< ##
## ------------------------------------------------------------------------------- ##

set dnschecker "1"
if {[catch {exec which nslookup} lookpath]} {
    putlog "$host/IP Banner and dnslookup proc disabled, error: $lookpath"
    set dnschecker "0"
    return 0
}
set from_ns "0"

bind raw - 311 raw:swi_wi311_ns
bind raw - 401 raw:swi_wi401_ns

proc pub_dns_lookup_req {nick host hand chan arg} {
 global where nshost from_ns dnschecker
 if {$dnschecker != "1"} {putserv "PRIVMSG $chan :$host/IP Banner and dnslookup proc disabled, error: $lookpath"; return 0}
 set where $chan
 set from_ns "1"
 set nshost [lrange $arg 0 end]
 if {$nshost == ""} {putserv "PRIVMSG $chan :Usage: !dns <host/ip/nick>"; return 0}
 putlog "DNSLOOKUP\: $nick Requested dns for ` $nshost `"
 putserv "WHOIS $nshost"
}

proc msg_dns_lookup_req {nick host hand arg} {
 global where nshost from_ns dnschecker
 if {$dnschecker != "1"} {putserv "PRIVMSG $msg :$host/IP Banner and dnslookup proc disabled, error: $lookpath"; return 0}
 set where $nick
 set from_ns "1"
 set nshost [lrange $arg 0 end]
 if {$nshost == ""} {putserv "PRIVMSG $nick :Usage: !dns <host/ip/nick>"; return 0}
 putlog "NSLOOKUP\: $nick Requested dns for ` $nshost `"
 putserv "WHOIS $nshost"
}

## nicht im IRC:
proc raw:swi_wi401_ns {from key arg} {
 global nshost whoisnick where
 set whoisnick "0"
 utimer 2 "do_dns_lookup $where $nshost"
}

## im IRC:
proc raw:swi_wi311_ns {from key arg} {
 global where whoisnick
 set whoisnick [lindex [split $arg] 1]
 set nshost [lindex [split $arg] 3]
 utimer 2 "do_dns_lookup $where $nshost"
}

proc do_dns_lookup {where nshost2} {
 global whoisnick from_ns
 if {$from_ns != "0"} {
 if {$whoisnick != "0"} {
     set msg "[b]dns[b]lookup Results for [u]$whoisnick[u] \:"
    } else {
     set msg "[b]dns[b]lookup Results for [u]$nshost2[u] \:"
    }
 set host_ip [dnslookup $nshost2]
 set name [lindex [split $host_ip :] 0]
 set ip [lindex [split $host_ip :] 1]
 putserv "PRIVMSG $where :$msg"
 putserv "PRIVMSG $where :$name [b]<->[b] $ip"
 set from_ns "0"
 set whoisnick "0"
 }
}
          
proc dnslookup {host} {
 global lookpath
 set name "Unknown"; set ip "Unknown"; set errmsg "Unknown";
 set server_lines 0
 set $host [lindex [string tolower $host] 0]
 if {[catch {exec $lookpath [lindex $host 0]} buff]} {
     foreach line [split $buff \n] {
      if {[string first "${host}:" $line] != -1} {
	  set errmsg [string trim [lindex [split $line :] 1]]
	 }
     }
      return "Error:$errmsg"
     }
 set buff [split $buff \n]
 set buff [lreplace $buff 0 1]
 foreach data $buff {
  switch [lindex $data 0] {
    "Name:" {
	  set name [string trim [lindex [split $data :] 1]]
	 }
    "Address:" {
	  set ip [string trim [lindex [split $data :] 1]]
	 }
     "Addresses:" {
	  set ip [string trim [lindex [split $data :] 1]]
	 }
   }
  }
 return "${name}:${ip}"
}


proc u {} {return \037};                  #underline
proc r {} {return \026};                  #reverse
proc b {} {return \002};                  #bold
proc c {} {return \003};                  #color 
proc a {} {return \001};                  #action

putlog "DNSlookUP loaded by physicus"
