# Default Settings
set xtCChannel 	"#e-c-h-o"
set xtCPointsName 	"Jackpot"
set xtCPointsPerAnswer 10
set xtCQuestionTime 	60
set xtCMarker 		"*"
set xtCScoreFile 	"game.scores"
set xtCAskedFile	"game.asked"
set xtCQuestionFile	"scripts/game1.txt"
set xtCCFGFile		"scripts/game.cfg"

# Channel Triggers
bind pub - !top10 xtCTop10
bind pub - !topbulan xtCLastMonthTop3
bind pub - !poin xtCPlayerScore
bind pub - !ulang xtC_Repeat
bind pub - !help xtCCmds
bind pub - !data xtC_ShowAsked
bind pub - !mulai xtC_Start
bind pub - !berhenti xtC_Stop

# DCC Commands
bind dcc - gamerehash dcc_gamerehash
bind dcc - gameanswer dcc_gameanswer
bind dcc - gamereset dcc_gameresetasked
bind dcc - gameasked dcc_gameshowasked
bind dcc - gameforce dcc_gameforce

# Cron Bind For Monthly Score Reset
bind time - "00 00 01 * *" xtC_NewMonth

# Global Variables
set xtCRunning 0
set xtCAllAnswered 0
set xtCRoundOver 0
set xtCQNumber 0
set xtCQuestion ""
set xtCQuestions(0) ""
set xtCAsked ""
set xtCMonthFileName ""
set xtCQCount 0
set xtCAnswerCount 0
set xtCDisplayNum 0
set xtCNumAnswered 0
set xtCForced 0
set xtCForcedQuestion ""
set xtCAutoStart 0

# Scores And Ads
set xtCAdNumber 0
set xtCAd(0) "$botnick"
set xtCAd(1) "$botnick"
set xtCAd(2) "$botnick"
set xtCAd(3) "$botnick"
set xtCAd(4) "$botnick"
set xtCAd(5) "$botnick"
set xtCAd(6) "$botnick"
set xtCAd(7) "$botnick"
set xtCAd(8) "$botnick"
set xtCAd(9) "$botnick"
set xtCLastMonthScores(0) "Nobody 0"
set xtCLastMonthScores(1) "Nobody 0"
set xtCLastMonthScores(2) "Nobody 0"

# Timers
set xtCAdTimer ""
set xtCQuestionTimer ""

# Version
set KDebug 0
set xtCVersion "2005 - xtC"

#
# Start xtC
#
proc xtC_Start {nick uhost hand chan args} {
 global xtCChannel xtCRunning xtCQCount xtCQNumber xtCQuestionFile xtCAdNumber xtCVersion KDebug

 if {($chan != $xtCChannel)||($xtCRunning != 0)} {return}

 set xtCQCount 0
 set xtCAdNumber 0

 xtC_ReadCFG

 if {![file exist $xtCQuestionFile]} {
   putcmdlog "\[xtC\] Question File: $xtCQuestionFile Unreadable Or Does Not Exist"
   return 0
 }

 set xtCQCount [xtC_ReadQuestionFile]

 if {$xtCQCount < 2} {
   putcmdlog "\[xtC\] Not Enough Questions in Question File $xtCQuestionFile"
   return 0
 }

 set xtCAskedFileLen [xtC_ReadAskedFile]

 if {$xtCAskedFileLen >= $xtCQCount} {
   gamemsg "aikmel F100 [kcr] All Questions Asked: Resetting \003"
   xtC_ResetAsked
   return 0
 }

 set xtCRunning 1

 gamemsg "aikmel F100 [kcm] v$xtCVersion by SkyStrom \[$xtCQCount Questions\] \003"

 bind pubm - "*" xtCCheckGuess

 xtCAskQuestion

 return 1
}

#
# Stop xtC
#
proc xtC_Stop {nick uhost hand chan args} {
 global xtCChannel xtCRunning xtCQuestionTimer xtCAdTimer

 if {($chan != $xtCChannel)||($xtCRunning != 1)} {return}

 set xtCRunning 0

 catch {killutimer $xtCQuestionTimer}
 catch {killutimer $xtCAdTimer}

 catch {unbind pubm - "*" xtCCheckGuess}

 gamemsg "aikmel F100 \00306stopped by \00304\[\00312$nick!$uhost\00304\]"
 return 1
}

#
# Pick Question
#
proc xtCPickQuestion {} {
 global xtCAsked xtCQCount KDebug
 set xtCUnasked [expr ($xtCQCount - [llength $xtCAsked])]
 if {$xtCUnasked < 1} {
   gamemsg "aikmel F100 [kcr] All Questions Asked: Resetting \003"
   xtC_ResetAsked
 }
 set pickdone 0
 while {$pickdone == 0} {
  set kidx 0
  set foundinasked 0
  set pick [rand $xtCQCount]
  while {[lindex $xtCAsked $kidx] != ""} {
    if {[lindex $xtCAsked $kidx] == $pick} {
     set foundinasked 1
     # gamelog "xtC" "Found Pick:$pick in Asked"
     break
    }
    incr kidx
  }
  if {$foundinasked == 0} {incr pickdone}
 }
 # gamelog "xtC" "Picked Question:$pick"
 xtC_AddAsked $pick
 return $pick
}

#
# Parse Question
#
proc xtCParseQuestion {QNum} {
 global xtCMarker xtCQuestions xtCQuestion xtCAnswers xtCAnswerCount xtCForcedQuestion KDebug

  set KAnswersLeft ""

  if {$QNum < 0} {
   set xtCFileQuestion $xtCForcedQuestion
  } {
   set xtCFileQuestion $xtCQuestions($QNum)
  }

  if {$KDebug > 1} {gamelog "game" "Picked:$QNum Question:$xtCFileQuestion"}

  if [info exists xtCAnswers] {unset xtCAnswers}

  # Position of first "*"

  set xtCMarkerIDX [string first $xtCMarker $xtCFileQuestion]

  if {$xtCMarkerIDX < 1} {
   gamelog "xtC" "Malformed Question #$QNum"
  }

  set xtCQuestionEndIDX [expr $xtCMarkerIDX - 1]

  set xtCQuestion [string range $xtCFileQuestion 0 $xtCQuestionEndIDX]

  # Move to first character in answers
  incr xtCMarkerIDX
  set KAnswersLeft [string range $xtCFileQuestion $xtCMarkerIDX end]

  set KDoneParsing 0
  set xtCAnswerCount 0

  # Parse all answers

  while {$KDoneParsing != 1 } {
   set KAnswerEnd [string first $xtCMarker $KAnswersLeft]

   if {$KAnswerEnd < 1} {
    set KDoneParsing 1
    set KAnswerEnd [string length $KAnswersLeft]
   }

   set KAnswer [string range $KAnswersLeft 0 [expr $KAnswerEnd -1]]

   set xtCAnswers($xtCAnswerCount) "# $KAnswer"

   set xtCMarkerIDX [expr $KAnswerEnd +1]

   set KAnswersLeft [string range $KAnswersLeft $xtCMarkerIDX end]
   incr xtCAnswerCount
  }
}

#
# Ask Question
#
proc xtCAskQuestion {} {
 global xtCRunning xtCQNumber xtCAllAnswered xtCRoundOver xtCQuestion
 global xtCPointsPerAnswer xtCPointsName xtCNumAnswered xtCAnswerCount
 global xtCQuestionTimer xtCQuestionTime xtCDisplayNum xtCForced xtCLastGuesser

 if {$xtCRunning != 1} {return}

 # Get The Current Scores
 read_xtCScore

 # Pick Next Question

 if {$xtCForced == 1} {
  xtCParseQuestion -1
  set xtCQNumber 0
  set xtCForced 0
  set xtCForcedQuestion ""
 } {
  set xtCQNumber [xtCPickQuestion]
  xtCParseQuestion $xtCQNumber
 }

 set xtCAllAnswered 0
 set xtCLastGuesser ""
 set xtCDisplayNum 0
 set xtCNumAnswered 0
 set xtCRoundOver 0

 # Choose Points Value For This Round
 set xtCPointsPerAnswer [rand 10]
 if {$xtCPointsPerAnswer < 1} {set xtCPointsPerAnswer 10}
 set xtCPointsPerAnswer [expr $xtCPointsPerAnswer * 10]

 set xtCPointTotal [expr $xtCPointsPerAnswer *$xtCAnswerCount]

 gamemsg "[kcg] Pertanyaan No:[format "%04d" $xtCQNumber] [kcb] $xtCQuestion \003 \00306\[\00310$xtCAnswerCount \00306Jawaban\]\003"
 gamemsg "\00313$xtCPointsPerAnswer \00312$xtCPointsName \00306Jika Kamu Dapat Menjawab 1 Jawaban Dengan Benar. \00310Total: \00313$xtCPointTotal \00312$xtCPointsName\003"
 gamemsg "8,4..::..F100 Game By SkyStrom - aikmel Team..::.."
 
 set KRemain [expr int([expr $xtCQuestionTime /2])]
 set xtCQuestionTimer [utimer $KRemain "xtCDisplayRemainingTime $KRemain"]
}

#
# Get Player Guess
#

proc xtCCheckGuess {nick uhost hand chan args} {
 global xtCChannel xtCRunning xtCScore xtCAnswerCount xtCAnswers xtCRoundOver
 global xtCPointsName xtCPointsPerAnswer xtCNumAnswered xtCAllAnswered xtCLastGuesser KDebug

 if {($chan != $xtCChannel)||($xtCRunning != 1)||($xtCRoundOver == 1)} {return}

 regsub -all \[{',.!}] $args "" args

 if {[string length args] == 0} {return}

 set xtCGuessOld $args
 set xtCGuess [string tolower $xtCGuessOld]

 if {$KDebug > 1} {gamelog "xtC" "Guess: $nick $xtCGuess"}

 foreach z [array names xtCAnswers] {
  set xtCTry [lrange $xtCAnswers($z) 1 end] 
  set xtCTryOld $xtCTry

  regsub -all \[{',.!}] $xtCTry "" xtCTry

  set xtCTry [string tolower $xtCTry]
  if {$KDebug > 1} {gamelog "xtC" "Try: $xtCTry"}

  if {$xtCTry == $xtCGuess} {
   if {[lindex $xtCAnswers($z) 0] == "#"} {
    set xtCAnswers($z) "$nick $xtCGuessOld"
    gamemsg "[knikclr $nick]\00306 mendapatkan \00313$xtCPointsPerAnswer \00312$xtCPointsName \00306dari jawaban : \00310$xtCTryOld"
    incr xtCNumAnswered
    if {$xtCNumAnswered == $xtCAnswerCount} {
     set xtCAllAnswered 1
     set xtCRoundOver 1
     set xtCLastGuesser $nick
     gamemsg "aikmel F100 [kcr] You've Guessed Them All! Well Done! \003"
     xtC_ShowResults
     xtC_Recycle
    }
    return
   }
  }
 }
}

#
# Display Remaining Time And Answer Stats
#
proc xtCDisplayRemainingTime {remaining} {
 global xtCRunning xtCAllAnswered xtCNumAnswered xtCAnswerCount xtCQuestionTimer xtCQuestionTime xtCDisplayNum

 if {($xtCRunning != 1)||($xtCAllAnswered == 1)} {return}

 gamemsg "\00306Telah Terjawab = $xtCNumAnswered  \00308,02 Total Jawaban $xtCAnswerCount \003 \00312$remaining \00306Detik lagi"

 incr xtCDisplayNum

 set KRemain [expr int([expr $xtCQuestionTime /4])]

 if {$xtCDisplayNum < 2} {
  set xtCQuestionTimer [utimer $KRemain "xtCDisplayRemainingTime $KRemain"]
 } {
  set xtCQuestionTimer [utimer $KRemain xtCTimesUp]
 }
}

#
# Show Results Of Round
#
proc xtCTimesUp {} {
 global xtCAnswers xtCAllAnswered xtCRoundOver xtCNumAnswered xtCAnswerCount xtCQuestionTimer xtCAdTimer

 if {$xtCAllAnswered == 1} { return 1}

 set xtCRoundOver 1

 set gamemissed "[kcg] Time's Up! \003 "

 append KMissed "\00304 hehehe  \00312"

 set KAnswersRemaining [expr ($xtCAnswerCount - $xtCNumAnswered)]

 set kcount 0
 foreach z [array names xtCAnswers] {
  if {[lindex $xtCAnswers($z) 0] == "#"} {
   append KMissed "\00312[lrange $xtCAnswers($z) 1 end]"
   incr kcount
   if {$kcount < $KAnswersRemaining} {append KMissed " \00311| "}
  }
 }

 gamemsg "$KMissed\003"

 xtC_ShowResults

 if {$xtCNumAnswered > 0} {
  gamemsg "[kcs] Total Number Answered Correctly:  $xtCNumAnswered from a possible $xtCAnswerCount! \003"
 } {
  gamemsg "aikmel F100 \00304Continue! \00310tunggu 10 detik kita mulai ke pertanyaan yg baru \003"
 }

 set xtCAdTimer [utimer 10 xtC_ShowAd]

 set xtCQuestionTimer [utimer 20 xtCAskQuestion]
}

#
# All Answers Gotten, Next Question
#
proc xtC_Recycle {} {
 global xtCAnswers xtCNumAnswered xtCQuestionTimer xtCAdTimer
 catch {killutimer $xtCQuestionTimer}
 if [info exists xtCAnswers] {unset xtCAnswers}
 set xtCAdTimer [utimer 10 xtC_ShowAd]
 set xtCQuestion ""
 set xtCNumAnswered 0
 set xtCQuestionTimer [utimer 20 xtCAskQuestion]
}

#
# Total Answers and Points
#
proc xtC_ShowResults {} {
 global xtCAnswers xtCPointsPerAnswer xtCPointsName xtCScore xtCAllAnswered xtCLastGuesser

 set NickCounter 0
 set xtCCounter 0

 if {$xtCAllAnswered == 1} {
  set xtCBonus [expr $xtCPointsPerAnswer *10]
  gamemsg "[knikclr $xtCLastGuesser]\00306 Wins \00313$xtCBonus \00312BONUS!! $xtCPointsName \00306telah Menjawab Jawaban Terakhir! -xtC-"
  set KNickTotals($xtCLastGuesser) $xtCBonus
  set KNickList($NickCounter) $xtCLastGuesser
  incr NickCounter
 }

 foreach z [array names xtCAnswers] {
  if {[lindex $xtCAnswers($z) 0] != "#"} {
   set cnick [lindex $xtCAnswers($z) 0]
   if {[info exists KNickTotals($cnick)]} {
    incr KNickTotals($cnick) $xtCPointsPerAnswer
   } {
    set KNickTotals($cnick) $xtCPointsPerAnswer
    set KNickList($NickCounter) $cnick
    incr NickCounter
   }
   incr xtCCounter
  }
 }

 if {$xtCCounter > 0} {
  set ncount 0
  set nicktotal "[kcm] $xtCPointsName Tertinggi Untuk Babak Permainan ini adalah sbg: "
  while {$ncount < $NickCounter} {
   set cnick $KNickList($ncount)
   if {[info exists xtCScore($cnick)]} {
     incr xtCScore($cnick) $KNickTotals($cnick)
   } {
     set xtCScore($cnick) $KNickTotals($cnick)
   }
   append nicktotal "[kcc] $cnick [kcm] $KNickTotals($cnick) "
   incr ncount
  }
  gamemsg $nicktotal
  write_xtCScore
 }
}

#
# Read Scores
#
proc read_xtCScore { } {
 global xtCScore xtCScoreFile
 if [info exists xtCScore] { unset xtCScore }
 if {[file exists $xtCScoreFile]} {
  set f [open $xtCScoreFile r]
  while {[gets $f s] != -1} {
   set xtCScore([lindex $s 0]) [lindex $s 1]
  }
  close $f
  } {
   set f [open $xtCScoreFile w]
   puts $f "Nobody 0"
   close $f
  }
}

#
# Write Scores
#
proc write_xtCScore {} {
 global xtCScore xtCScoreFile
 set f [open $xtCScoreFile w]
 foreach s [lsort -decreasing -command sort_xtCScore [array names xtCScore]] {
  puts $f "$s $xtCScore($s)"
 }
 close $f
}

#
# Score Sorting
#
proc sort_xtCScore {s1 s2} {
 global xtCScore
 if {$xtCScore($s1) >  $xtCScore($s2)} {return 1}
 if {$xtCScore($s1) <  $xtCScore($s2)} {return -1}
 if {$xtCScore($s1) == $xtCScore($s2)} {return 0}
}

#
# Add Question Number To Asked File
#
proc xtC_AddAsked {Qnum} {
 global xtCAsked xtCAskedFile
 set f [open $xtCAskedFile a]
 puts $f $Qnum
 close $f
 lappend xtCAsked $Qnum
}

#
# Parse Asked Questions
#
proc xtC_ReadAskedFile {} {
 global xtCAsked xtCAskedFile
 set KAsked 0
 set xtCAsked ""
 if {![file exists $xtCAskedFile]} {
  set f [open $xtCAskedFile w]
 } {
  set f [open $xtCAskedFile r]
  while {[gets $f Qnum] != -1} {
   lappend xtCAsked "$Qnum"
   incr KAsked
  }
 }
 close $f
 return $KAsked
}

#
# Reset Asked File
#
proc xtC_ResetAsked {} {
 global xtCAskedFile xtCAsked
 set f [open $xtCAskedFile w]
 puts $f "0"
 close $f
 set xtCAsked ""
}

#
# Read Question File
#
proc xtC_ReadQuestionFile {} {
 global xtCQuestionFile xtCQuestions
 set Questions 0
 set f [open $xtCQuestionFile r]
 while {[gets $f q] != -1} {
  set xtCQuestions($Questions) $q
  incr Questions
 }
 close $f
 return $Questions
}

#
# Show Asked
#
proc xtC_ShowAsked {nick uhost hand chan args} {
 global xtCQCount xtCAsked xtCQuestions
 set xtCStatsAsked [llength $xtCAsked]
 set xtCStatsUnasked [expr ($xtCQCount - $xtCStatsAsked)]
 gamemsg "aikmel F100 [kcm] Total: [kcc] $xtCQCount [kcm] Asked: [kcc] $xtCStatsAsked [kcm] Remaining: [kcc] $xtCStatsUnasked \003"
}

#
# Repeat Question
#
proc xtC_Repeat {nick uhost hand chan args} {
 global xtCChannel xtCQuestion xtCRunning xtCQNumber xtCAllAnswered
 global xtCPointsName
 if {($chan != $xtCChannel)||($xtCRunning != 1)} {return}
 if {$xtCAllAnswered == 1} {return }
 gamemsg "\00300,03 Pengulangan Pertanyaan No:[format "%04d" $xtCQNumber] \00308,02 $xtCQuestion \003"
}

#
# Display User's Score
#
proc xtCPlayerScore {nick uhost hand chan args} {
 global xtCChannel xtCScoreFile xtCPointsName

 if {$chan != $xtCChannel} {return}

 regsub -all \[`,.!{}] $args "" args

 if {[string length $args] == 0} {set args $nick}

 set scorer [string tolower $args]

 set kflag 0

 set f [open $xtCScoreFile r]
 while {[gets $f sc] != -1} {
  set cnick [string tolower [lindex $sc 0]]
  if {$cnick == $scorer} {
   gamemsg "[kcm] [lindex $sc 0] [kcc] [lindex $sc 1] $xtCPointsName \003"
   set kflag 1
  }
 }
 if {$kflag == 0} {gamemsg "[kcm] $scorer [kcc] No Score \003"}
 close $f
}

#
# Display Top 10 Scores To A Player
#
proc xtCTop10 {nick uhost hand chan args} {
 global xtCChannel xtCScoreFile xtCPointsName
 if {$chan != $xtCChannel} {return}
 set KWinners "[kcm] Top10 aikmel F100 $xtCPointsName "
 set f [open $xtCScoreFile r]
 for { set s 0 } { $s < 10 } { incr s } {
  gets $f xtCTotals
  if {[lindex $xtCTotals 1] > 0} {
   append KWinners "[kcm] #[expr $s +1] [kcc] [lindex $xtCTotals 0] [lindex $xtCTotals 1] "
  } {
   append KWinners "[kcm] #[expr $s +1] [kcc] Nobody 0 "
  }
 }
 gamemsg "$KWinners"
 close $f
}

#
# Last Month's Top 3
#
proc xtCLastMonthTop3 {nick uhost hand chan args} {
 global xtCChannel xtCLastMonthScores
 if {$chan != $xtCChannel} {return}
 if [info exists xtCLastMonthScores] {
  set KWinners "[kcm] 3 orang Pemenang Bulan Yang Lalu - aikmel F100 "
  for { set s 0} { $s < 3 } { incr s} {
   append KWinners "[kcm] #[expr $s +1] [kcc] $xtCLastMonthScores($s) "
  }
  gamemsg "$KWinners"
 }
}

#
# Read Config File
#
proc xtC_ReadCFG {} {
 global xtCCFGFile xtCChannel xtCAutoStart xtCScoreFile xtCAskedFile xtCQuestionFile xtCLastMonthScores xtCPointsName xtCAd
 if {[file exist $xtCCFGFile]} {
  set f [open $xtCCFGFile r]
  while {[gets $f s] != -1} {
   set kkey [string tolower [lindex [split $s "="] 0]]
   set kval [lindex [split $s "="] 1]
   switch $kkey {
    points { set xtCPointsName $kval }
    channel { set xtCChannel $kval }
    autostart { set xtCAutoStart $kval }
    scorefile { set xtCScoreFile $kval }
    askedfile { set xtCAskedFile $kval }
    gamefile { set xtCQuestionFile $kval }
    ad1 { set xtCAd(0) $kval }
    ad2 { set xtCAd(1) $kval }
    ad3 { set xtCAd(2) $kval }
    ad4 { set xtCAd(3) $kval }
    ad5 { set xtCAd(4) $kval }
    ad6 { set xtCAd(5) $kval }
    ad7 { set xtCAd(6) $kval }
    ad8 { set xtCAd(7) $kval }
    ad9 { set xtCAd(8) $kval }
    ad10 { set xtCAd(9) $kval }
    lastmonth1 { set xtCLastMonthScores(0) $kval }
    lastmonth2 { set xtCLastMonthScores(1) $kval }
    lastmonth3 { set xtCLastMonthScores(2) $kval }
   }
  }
  close $f
  if {($xtCAutoStart < 0)||($xtCAutoStart > 1)} {set xtCAutoStart 1}
  return
 }
 gamelog "xtC" "Config file $xtCCFGFile not found... using defaults"
}

#
# Write Config File
#
proc xtC_WriteCFG {} {
 global xtCCFGFile xtCChannel xtCAutoStart xtCScoreFile xtCAskedFile xtCQuestionFile xtCLastMonthScores xtCPointsName xtCAd
 set f [open $xtCCFGFile w]
 puts $f "# This file is automatically overwritten"
 puts $f "Points=$xtCPointsName"
 puts $f "Channel=$xtCChannel"
 puts $f "AutoStart=$xtCAutoStart"
 puts $f "ScoreFile=$xtCScoreFile"
 puts $f "AskedFile=$xtCAskedFile"
 puts $f "xtCFile=$xtCQuestionFile"
 puts $f "LastMonth1=$xtCLastMonthScores(0)"
 puts $f "LastMonth2=$xtCLastMonthScores(1)"
 puts $f "LastMonth3=$xtCLastMonthScores(2)"
 puts $f "Ad1=$xtCAd(0)"
 puts $f "Ad2=$xtCAd(1)"
 puts $f "Ad3=$xtCAd(2)"
 puts $f "Ad4=$xtCAd(3)"
 puts $f "Ad5=$xtCAd(4)"
 puts $f "Ad6=$xtCAd(5)"
 puts $f "Ad7=$xtCAd(6)"
 puts $f "Ad8=$xtCAd(7)"
 puts $f "Ad9=$xtCAd(8)"
 puts $f "Ad10=$xtCAd(9)"
 close $f
}

#
# Clear Month's Top 10
#
proc xtC_NewMonth {min hour day month year} {
 global xtCScoreFile xtCScore xtCLastMonthScores

 set cmonth [expr $month +1]
 set lmonth [xtCLastMonthName $cmonth]

 gamemsg "aikmel F100 [kcr] hapus score tiap-tiap bulan! \003"

 set xtCMonthFileName "$xtCScoreFile.$lmonth"

 set f [open $xtCMonthFileName w]
 set s 0
 foreach n [lsort -decreasing -command sort_xtCScore [array names xtCScore]] {
  puts $f "$n $xtCScore($n)"
  if {$s < 3} {
   if {$xtCScore($n) > 0} {
    set xtCLastMonthScores($s) "$n $xtCScore($n)"
   } {
    set xtCLastMonthScores($s) "Nobody 0"
   }
  }
  incr s
 }
 close $f

 xtC_WriteCFG

 if [info exists xtCScore] {unset xtCScore}

 set f [open $xtCScoreFile w]
 puts $f "Nobody 0"
 close $f

 putcmdlog "\[xtC\] Cleared aikmel F100 Monthly Top10 Scores: $xtCMonthFileName"
}

#
# Command Help
#
proc xtCCmds {nick uhost hand chan args} {
 global xtCChannel
 if {$chan != $xtCChannel} {return}
 gamentc $nick "aikmel F100 Commands: !top10 !poin \[nick\] !ulang !topbulan !mulai !berhenti"
}

#
# Color Routines
#
proc kcb {} {
 return "\0038,2"
}
proc kcg {} {
 return "\0030,12"
}
proc kcr {} {
 return "\0030,4"
}
proc kcm {} {
 return "\0030,7"
}
proc kcc {} {
 return "\0030,1"
}
proc kcs {} {
 return "\0030,13"
}
proc game {} {
 return "\00307x\00313t\00306C\003"
}

# Channel Message
proc gamemsg {what} {
 global xtCChannel
 putquick "PRIVMSG $xtCChannel :$what"
}

# Notice Message
proc gamentc {who what} {
 putquick "NOTICE $who :$what"
}
# Command Log
proc gamelog {who what} {
 putcmdlog "\[$who\] $what"
}

# Name Of Last Month
proc xtCLastMonthName {month} {
 switch $month {
  1 {return "Dec"}
  2 {return "Jan"}
  3 {return "Feb"}
  4 {return "Mar"}
  5 {return "Apr"}
  6 {return "May"}
  7 {return "Jun"}
  8 {return "Jul"}
  9 {return "Aug"}
  10 {return "Sep"}
  11 {return "Oct"}
  12 {return "Nov"}
  default {return "???"}
 }
}

# Assign Nickname Color
proc knikclr {nick} {
  set nicklen [strlen $nick]
  set nicktot 0
  set c 0
  while {$c < $nicklen} {
   binary scan [string range $nick $c $c] c nv
   incr nicktot [expr $nv -32]
   incr c
  }
  set nickclr [expr $nicktot %13]
  switch $nickclr {
   0 {set nickclr 10}
   1 {set nickclr 11}
   2 {set nickclr 12}
   5 {set nickclr 13}
  }
  set nik [format "%02d" $nickclr]
  return "\003$nik$nick"
}

#
# Show Ad
#
proc xtC_ShowAd {} {
 global xtCAdNumber xtCAd botnick xtCChannel
 switch $xtCAdNumber {
  0 { gamemsg "[kcs] $xtCAd(0) \003" }
  1 { xtCTop10 $botnick none none $xtCChannel none }
  2 { gamemsg "[kcs] $xtCAd(1) \003" }
  3 { xtCLastMonthTop3 $botnick none none $xtCChannel none }
  4 { gamemsg "[kcs] $xtCAd(2) \003" }
  5 { xtCLastMonthTop3 $botnick none none $xtCChannel none }
  6 { gamemsg "[kcs] $xtCAd(3) \003" }
  7 { xtCLastMonthTop3 $botnick none none $xtCChannel none }
  8 { gamemsg "[kcs] $xtCAd(4) \003" }
  9 { xtCLastMonthTop3 $botnick none none $xtCChannel none }
  10 { gamemsg "[kcs] $xtCAd(5) \003" }
  11 { xtCLastMonthTop3 $botnick none none $xtCChannel none }
  12 { gamemsg "[kcs] $xtCAd(6) \003" }
  13 { xtCLastMonthTop3 $botnick none none $xtCChannel none }
  14 { gamemsg "[kcs] $xtCAd(7) \003" }
  15 { xtCLastMonthTop3 $botnick none none $xtCChannel none }
  16 { gamemsg "[kcs] $xtCAd(8) \003" }
  17 { xtCLastMonthTop3 $botnick none none $xtCChannel none }
  18 { gamemsg "[kcs] $xtCAd(9) \003" }
  
 }
 incr xtCAdNumber
 if {$xtCAdNumber > 18} {set xtCAdNumber 0}
}

#
# Rehash xtC Config
#
proc dcc_gamerehash {hand idx arg} {
 global xtCQCount

 putcmdlog "#$hand# Rehashing xtC config"

 xtC_ReadCFG

 set xtCQCount [xtC_ReadQuestionFile]

 if {$xtCQCount < 2} {
   gamelog "xtC" "Not Enough Questions in Question File $xtCQuestionFile"
   return 0
 }

 set xtCAskedFileLen [xtC_ReadAskedFile]

 if {$xtCAskedFileLen >= $xtCQCount} {
   gamelog "xtC" "Asked file out of sync with question database: resetting"
   xtC_ResetAsked
   return 0
 }
 gamelog "xtC" "Questions:$xtCQCount Asked:$xtCAskedFileLen Remaining:[expr ($xtCQCount - $xtCAskedFileLen)]"
}

#
# Show Current Answers
#
proc dcc_gameanswer {hand idx arg} {
 global xtCAnswers
 set ans ""
 foreach z [array names xtCAnswers] {
  if {[lindex $xtCAnswers($z) 0] == "#"} {
   append ans "[lrange $xtCAnswers($z) 1 end] | "
  }
 }
 gamelog "xtC" $ans
}

#
# Reset Asked File
#
proc dcc_gameresetasked {hand idx arg} {
 xtC_ResetAsked
 gamelog "xtC" "#$hand# Reset Asked File"
}

#
# Show Asked
#
proc dcc_gameshowasked {hand idx arg} {
 global xtCQCount xtCAsked xtCQuestions
 set xtCStatsAsked [llength $xtCAsked]
 set xtCStatsUnasked [expr ($xtCQCount - $xtCStatsAsked)]
 gamelog "xtC" "Total:$xtCQCount  Asked:$xtCStatsAsked  Remaining:$xtCStatsUnasked"
}

#
# Force A Question
#
proc dcc_gameforce {hand idx arg} {
 global xtCRunning xtCMarker xtCForced xtCForcedQuestion
 if {$xtCRunning != 1} {return}
 regsub -all \[`,.!{}] $arg "" arg
 if {$arg == ""} {return}
 set xtCMarkerIDX [string first $xtCMarker $arg]
 if {$xtCMarkerIDX < 2} {
  gamelog "xtC" "Malformed question: Format: Question *Answer1*Answer2..."
  return
 }
 set xtCForcedQuestion $arg
 set xtCForced 1
 gamelog "xtC" "Forcing A Question Next Round"
}

xtC_ReadCFG

putcmdlog "aikmel F100 $xtCVersion creation by SkyStrom"
