############################################################################
# SecurityFocus by Ofloo
# Gets the latest 10 new xploits from securityfocus.com
# CVS: http://cvs.ofloo.net/
# HomePage: http://www.ofloo.net/
# Mail: support[at]ofloo.net
############################################################################
# Install:
#  - Put the script into your script dir (scripts)
#  - Load the script by adding "source scripts/securityfocus.tcl" to 
#    eggdrop.conf without the quotes (")
############################################################################

############################################################################
# SETTINGS

set secu(trigger) "!secu"
set secu(wwwhost) "www.securityfocus.com"
set secu(wwwport) "80"
set secu(vrs) "0.1"

############################################################################
# BINDS

bind pub - !secu secu:pub

############################################################################
# PROCS

proc secu:pub {nick host hand chan arg} {
  global secu
  catch {socket $secu(wwwhost) $secu(wwwport)} sock
  puts $sock "GET /rss/vulnerabilities.xml HTTP/1.1"
  puts $sock "Host: $secu(wwwhost)"
  puts $sock "Connection: Close"
  puts $sock "User-Agent: modified from ofloo.net"
  puts $sock "\n\r"
  while {![eof $sock]} {
    flush $sock
    gets $sock line
    if {[info exists data]} {
      append data $line
    } else {
      set data "$line"
    }
  }
  if {[info exists sock]} {
    close $sock
  }
  set data [string map {"<item>" "<item>\n" "</item>" "</item>\n" "</title>" "</title>\n" "</link>" "</link>\n" "</description>" "</description>\n"} [lindex [split [string map {"</image>" ""} $data] ""] 1]]
  foreach line [split $data \n] {
    if {[string match -nocase "<title>*</title>" $line]} {
      if {[info exists id]} {
        set id [expr $id+1]
        set title($id) [string map {"<title>" {} "</title>" {}} $line]
      } else {
        set id "1"
	set title($id) [string map {"<title>" {} "</title>" {}} $line]
      }
    }
    if {[string match -nocase "<link>*</link>" $line]} {
      if {[info exists id]} {
        set link($id) [string map {"<link>" {} "</link>" {}} $line]
      } else {
	putlog "\002Error array identifyer or array does not exist.\002"
      }
    }
    if {[string match -nocase "<description>*</description>" $line]} {
      if {[info exists id]} {
        set desc($id) [string map {"<description>" {} "</description>" {}} $line]
      } else {
        putlog "\002Error array identifyer or array does not exist.\002"
      }
    }
  }
  if {[string match -nocase {} [lindex $arg 0]]} {
    putserv "PRIVMSG $chan :Is not a valid command, type \002$secu(trigger) -help\002 for a list of commands."
  } elseif {[string match -nocase -list [lindex $arg 0]]} {
    if {[array exists title]} {
      putserv "PRIVMSG $chan :\002SecurityFocus\002 xploits list."
      for {set x 1} {$x <= 10} {incr x} {
        putserv "PRIVMSG $chan :\002ID: $x\002. $title($x)"
      }
    } else {
      putlog "\002Error there is no sutch array.\002"
    }
  } elseif {[string match -nocase -info [lindex $arg 0]]} {
    if {[regexp ^\[0-9\]+$ [lindex $arg 1]] && ![string match -nocase {} [lindex $arg 1]] && [string match -nocase {} [lindex $arg 2]]} {
      if {[array exists desc]} {
        if {[info exists desc([lindex $arg 1])]} {
          if {[lindex $arg 1] <= 10} {
	    putserv "PRIVMSG $chan :\002Descripton:\002 $desc([lindex $arg 1])"
          } else {
            putserv "PRIVMSG $chan :$nick there is no sutch element in array."
          }
	} else {
          putlog "\002Error there is no sutch element in the present array.\002"
        }
      } else {
      	putlog "\002Error array identifyer does not exist.\002"
      }
    } else {
      putlog "\002Error the chosen element is not a valid identifyer."
      putserv "PRIVMSG $chan :Error choose a element from the list."
    }
  } elseif {[string match -nocase -link [lindex $arg 0]]} {
    if {[regexp ^\[0-9\]+$ [lindex $arg 1]] && ![string match -nocase {} [lindex $arg 1]] && [string match -nocase {} [lindex $arg 2]]} {
      if {[array exists link]} {
        if {[info exists link([lindex $arg 1])]} {
          if {[lindex $arg 1] <= 10} {
	    putserv "PRIVMSG $chan :$link([lindex $arg 1])"
          } else {
            putserv "PRIVMSG $chan :$nick there is no sutch element in array."
          }
	} else {
          putlog "\002Error there is no sutch element in the present array.\002"
        }
      } else {
      	putlog "\002Error array identifyer does not exist.\002"
      }
    } else {
      putlog "\002Error the chosen element is not a valid identifyer."
      putserv "PRIVMSG $chan :Error choose a element from the list."
    }
  } elseif {[string match -nocase -credit [lindex $arg 0]] && [string match -nocase {} [lindex $arg 1]]} {
    putserv "PRIVMSG $chan :\002SecurityFocus\002 by Ofloo version \002$secu(vrs)\002 HomePage @ http://www.ofloo.net/"
  } elseif {[string match -nocase -help [lindex $arg 0]] && [string match -nocase {} [lindex $arg 1]]} {
    putserv "PRIVMSG $chan :\002SecurityFocus\002 command list:"
    putserv "PRIVMSG $chan :$secu(trigger) -list :: Show news titles."
    putserv "PRIVMSG $chan :$secu(trigger) -info <id> :: Shows topic description"
    putserv "PRIVMSG $chan :$secu(trigger) -link <id> :: Shows url that goes with the topic."
    putserv "PRIVMSG $chan :$secu(trigger) -credit :: Shows who made this script and where to get it."
  }
}

############################################################################
putlog "\002SecurityFocus\002 by Ofloo version \002$secu(vrs)\002"