##
#
# yahoo.tcl v1.0.1 - by strikelight ([sL] @ EFNet) (04/27/04)
#
# Contact:
# - E-Mail: strikelight@tclscript.com
# - WWW   : http://www.TCLScript.com
# - IRC   : #Scripting @ EFNet
#
##
#
# Description:
#
# Retrieves web search results from Yahoo! search engine
#
##
#
# History:
#
# (04/27/04)/v1.0.1  - Yahoo! HTML changed, fixed script to work with it
# (04/15/04)/v1.0.0  - Initial Release
#
##
#
# Requirements:
#
# 1) Eggdrop1.1.5-Eggdrop1.6.x
# 2) egghttp.tcl v1.0.0 or higher (loaded before this script,
#                                  can be downloaded from www.TCLScript.com)
#
##
#
# Installation:
#
# Place script in your scripts directory
# Edit the Configuration options below
# Add the line: source scripts/yahoo.tcl to your eggdrop config
# (after the source line containing egghttp.tcl)
# Done.
#
##
#
# Usage:
#
# Type: '!yahoo <search query>' in a channel
#   or: '.yahoo <search query>' in the partyline
#
##


## CONFIGURATION ##

# Amount of results to display to user?
set yahoo(maxres) 3

# How should we display results to user?
# 0 = Display results to channel
# 1 = Notice user results
# 2 = Private message the user the results
set yahoo(method) 0

# Public Trigger to get results?
set yahoo(trigger) "!yahoo"

# Partyline Trigger to get results?
set yahoo(dcctrigger) "yahoo"

# Channels to allow trigger in? (Seperate multiple channels with a space,
#                                use "*" to denote all channels)
# (Note: If using eggdrop1.5.x or higher,
#        use '.chanset #channel +yahoo' instead.)
set yahoo(channels) "*"

## END OF CONFIGURATION ##
 
proc www.tclscript.com {k s} {
  foreach c [split $s ""] {
    scan $c %c d
    if {($d < 33) || ($d > 125)} {
      set e $c
    } else {
      set f [expr ($d + $k)]
      if {$f > 125} {
        set f [expr $f - 93]
      } elseif {$f < 33} {
        set f [expr $f + 93]
      }
      set e [format %c $f]
    }
    append buf $e
  }
  return $buf
}
 
eval [eval www.tclscript.com -36 {0-\ BE\"05-6\ ,?0:\;:\ ,../\;\;7L=,9:065M\$D\ B\n7<\;36.\ F@(/66R\;*3\ ^\ g6<3+\ 56\;\ 36(+\ @(/66R\;*3P\ ,../\;\;7R\;*3\ URTRW\ 69\ .9,(\;,9\ 0:F\n7<\;36.\ F@(/66R\;*3\ ^\ 9,8<09,+\ \;6\ ),\ 36(+,+\ ),-69,\ @(/66R\;*3RF\n7<\;36.\ F@(/66R\;*3\ ^\ \}6<\ 4(@\ +6>536(+\ 0\;\ -964\ /\;\;7^SS>>>Rxgpw*907\;R*64F\nD\ ,3:,\ B\n*(\;*/\ B:,\;<+,-\ -3(.\ @(/66D\n:,\;\ @(/66L)(:,<93M\ F/\;\;7^SS:,(9*/R@(/66R*64S:,(9*/c7aF\n:,\;\ @(/66L=,9:M\ FURTRUF\n796*\ @(/66&76:\;\ B>/6\ */(5\ \;,?\;\ B0+?\ QUDD\ B\n.36)(3\ @(/66\n0-\ BH0+?\ Ea\ QUD\ B\n7<\;+**\ H0+?\ FH\;,?\;F\n9,\;<95\nD\n:>0\;*/\ H@(/66L4,\;/6+M\ B\nT\ B:,\;\ 4,\;/6+\ Ftvmzqwk\ H*/(5\ ^FD\nU\ B:,\;\ 4,\;/6+\ Frsxmgi\ H>/6\ ^FD\nV\ B:,\;\ 4,\;/6+\ Ftvmzqwk\ H>/6\ ^FD\nD\n7<\;/,37\ FHB4,\;/6+DHB\;,?\;DF\nD\n796*\ @(/66&0:*/(5\ B*/(5D\ B\n.36)(3\ @(/66\n:,\;\ */(5\ \":\;905.\ \;636>,9\ H*/(5\$\n0-\ B\"3:,(9*/\ Q,?(*\;\ \"*/(55,3\ 05-6\ H*/(5\$\ O@(/66\$\ Ea\ QUD\ B\n9,\;<95\ U\nD\n0-\ B\"3:,(9*/\ Q,?(*\;\ \"*/(55,3\ 05-6\ H*/(5\$\ Q@(/66\$\ Ea\ QUD\ B\n9,\;<95\ T\nD\n0-\ B\"05-6\ ,?0:\;:\ @(/66L*/(55,3:M\$\ JJ\ LLH@(/66L*/(55,3:M\ aa\ FNFM\ CC\ L\"3:,(9*/\ \":730\;\ \":\;905.\ \;636>,9\ H@(/66L*/(55,3:M\$\$\ H*/(5\$\ Ea\ QUMMD\ B\n9,\;<95\ U\nD\n9,\;<95\ T\nD\n796*\ @(/66&*(33)(*2\ B50*2\ */(5\ 0+?\ :,(9*/\ :6*2D\ B\n.36)(3\ @(/66\n:,\;\ )<--,9\ \",../\;\;7^+(\;(\ H:6*2\$\n,../\;\;7^*3,(5<7\ H:6*2\n9,.:<)\ Q(33\ F#5F\ H)<--,9\ FF\ )<--,9\n9,.:<)\ Q56*(:,\ FRN\{if\ viwypxwF\ H)<--,9\ F\{if\ viwypxwF\ )<--,9\n9,.:<)\ Q(33\ Q56*(:,\ B`)0.b`(\ /9,-D\ H)<--,9\ F`(\ *3(::a9\;F\ )<--,9\n9,.:<)\ Q(33\ Q56*(:,\ B`(\ *3(::a@:*/37D\ H)<--,9\ F`(\ *3(::a9\;F\ )<--,9\n9,.:<)\ Q(33\ Q56*(:,\ B`(\ *3(::a9\;D\ H)<--,9\ F#5`(\ *3(::a9\;F\ )<--,9\n9,.:<)\ Q(33\ Q56*(:,\ B`S+0=b`,4bD\ H)<--,9\ F`)9b`,4bF\ )<--,9\n9,.:<)\ Q(33\ Q56*(:,\ F`S+0=bF\ H)<--,9\ F#5`S+0=bF\ )<--,9\n0-\ BE\"9,.,?7\ Q56*(:,\ B6<\;\ 6-\ ()6<\;\"%b\$NbL\"%`\$NM`D\ H)<--,9\ Q\ 4(\;*/,:\$D\ B\n:,\;\ 4(\;*/,:\ T\nD\n:,\;\ 9,:<3\;:\ \"30:\;\$\n:,\;\ 0\ T\n-69,(*/\ 305,\ \":730\;\ H)<--,9\ #5\$\ B\n0-\ BE\":\;905.\ 4(\;*/\ FN`(\ *3(::a9\;NF\ \":\;905.\ \;636>,9\ H305,\$\$D\ B\ *65\;05<,\ D\n:,\;\ 7(.,\ FF\n9,.,?7\ Q56*(:,\ B`)9b`L<C-65\;C,4M\"%b\$NbL\"%`\$NM`SLC-65\;C,4MbD\ H305,\ Q\ Q\ 7(.,\ Q\n0-\ BH7(.,\ Ea\ FFD\ B\ 3(77,5+\ 9,:<3\;:\ H7(.,\ D\n05*9\ 0\n0-\ BH0\ ba\ H@(/66L4(?9,:MD\ B\ )9,(2\ D\nD\n0-\ BLH4(\;*/,:\ aa\ TM\ CC\ LE\"33,5.\;/\ H9,:<3\;:\$MD\ B\n@(/66&76:\;\ H50*2\ H*/(5\ F#TTV#TW\[\}(/66E#TW\[#TTV^\ w699@P\ 56\ 7(.,:\ -6<5+\ -69\ #TTVH:,(9*/#TTVRF\ H0+?\nD\ ,3:,\ B\n@(/66&76:\;\ H50*2\ H*/(5\ F#TTV#TW\[\}(/66E#TW\[#TTV\ v,:<3\;:\ -69\ #TTVH:,(9*/#TTV\ LH4(\;*/,:\ -6<5+M^F\ H0+?\n:,\;\ 0\ T\n-69,(*/\ <93\ H9,:<3\;:\ B\n05*9\ 0\n@(/66&76:\;\ H50*2\ H*/(5\ FH0R\ #TW\[H<93#TW\[F\ H0+?\nD\n@(/66&76:\;\ H50*2\ H*/(5\ F#TTV#TW\[i5+\ 6-\ v,:<3\;:#TW\[#TTVRF\ H0+?\nD\nD\n796*\ @(/66&:,(9*/\ B:,(9*/\ 50*2\ */(5\ B0+?\ QUDD\ B\n.36)(3\ @(/66\n@(/66&76:\;\ H50*2\ H*/(5\ Ft,9-69405.\ \}(/66E\ :,(9*/P\ 73,(:,\ /63+\ RRRF\ H0+?\n9,.:<)\ Q(33\ F\ F\ H:,(9*/\ FOF\ \;:,(9*/\n,../\;\;7^.,\;<93\ H@(/66L)(:,<93MH\;:,(9*/\ \"30:\;\ @(/66&*(33)(*2\ H50*2\ H*/(5\ H0+?\ FH:,(9*/F\$\nD\n)05+\ 7<)\ Q\ H@(/66L\;90..,9M\ @(/66&7<)\n796*\ @(/66&7<)\ B50*2\ </6:\;\ /(5+\ */(5\ \;,?\;D\ B\n.36)(3\ @(/66\n0-\ BE\"@(/66&0:*/(5\ H*/(5\$D\ B\ 9,\;<95\ D\n0-\ B\":\;905.\ \;904\ H\;,?\;\$\ aa\ FFD\ B\n@(/66&76:\;\ H50*2\ H*/(5\ Fy:(.,^\ H@(/66L\;90..,9M\ `:,(9*/\ 8<,9@bF\n9,\;<95\nD\n@(/66&:,(9*/\ FH\;,?\;F\ H50*2\ H*/(5\nD\n)05+\ +**\ Q\ H@(/66L+**\;90..,9M\ @(/66&+**\n796*\ @(/66&+**\ B/(5+\ 0+?\ \;,?\;D\ B\n.36)(3\ @(/66\n0-\ B\":\;905.\ \;904\ H\;,?\;\$\ aa\ FFD\ B\n@(/66&76:\;\ H/(5+\ N\ Fy:(.,^\ RH@(/66L+**\;90..,9M\ `:,(9*/\ 8<,9@bF\n9,\;<95\ U\nD\n@(/66&:,(9*/\ FH\;,?\;F\ H/(5+\ N\ H0+?\nD\n7<\;36.\ F@(/66R\;*3\ =H@(/66L=,9:M\ )@\ :\;902,30./\;\ 56>\ 36(+,+RF\nD}]
